#ifndef _DECL_receiver_H_
#define _DECL_receiver_H_
#include "charm++.h"
/* DECLS: message receiverMsg{
char buf[];
}
;
 */
class receiverMsg;
class CMessage_receiverMsg:public CkMessage{
  public:
    static int __idx;
    void* operator new(size_t, void*p) { return p; }
    void* operator new(size_t);
    void* operator new(size_t, int*, const int);
    void* operator new(size_t, int*);
#if CMK_MULTIPLE_DELETE
    void operator delete(void*p, void*){dealloc(p);}
    void operator delete(void*p){dealloc(p);}
    void operator delete(void*p, int*, const int){dealloc(p);}
    void operator delete(void*p, int*){dealloc(p);}
#endif
    void operator delete(void*p, size_t){dealloc(p);}
    static void* alloc(int,size_t, int*, int);
    static void dealloc(void *p);
    CMessage_receiverMsg() {};
    static void *pack(receiverMsg *p);
    static receiverMsg* unpack(void* p);
    void *operator new(size_t, int);
    void *operator new(size_t, int, const int);
#if CMK_MULTIPLE_DELETE
    void operator delete(void *p, int){dealloc(p);}
    void operator delete(void *p, int, const int){dealloc(p);}
#endif
    static void __register(const char *s, size_t size, CkPackFnPtr pack, CkUnpackFnPtr unpack) {
      __idx = CkRegisterMsg(s, pack, unpack, size);
    }
};

/* DECLS: array receiver: ArrayElement{
receiver(CkMigrateMessage* impl_msg);
receiver(void);
void generic(receiverMsg* impl_msg);
threaded sync void syncSend(receiverMsg* impl_msg);
void ready2go(void);
};
 */
 class receiver;
 class CkIndex_receiver;
 class CProxy_receiver;
 class CProxyElement_receiver;
 class CProxySection_receiver;
/* --------------- index object ------------------ */
class CkIndex_receiver:public CProxyElement_ArrayElement{
  public:
    typedef receiver local_t;
    typedef CkIndex_receiver index_t;
    typedef CProxy_receiver proxy_t;
    typedef CProxyElement_receiver element_t;
    typedef CProxySection_receiver section_t;

    static int __idx;
    static void __register(const char *s, size_t size);
/* DECLS: receiver(CkMigrateMessage* impl_msg);
 */
    static int __idx_receiver_CkMigrateMessage;
    static int ckNew(CkMigrateMessage* impl_msg) { return __idx_receiver_CkMigrateMessage; }
    static void _call_receiver_CkMigrateMessage(void* impl_msg,receiver* impl_obj);

/* DECLS: receiver(void);
 */
    static int __idx_receiver_void;
    static int ckNew(void) { return __idx_receiver_void; }
    static void _call_receiver_void(void* impl_msg,receiver* impl_obj);

/* DECLS: void generic(receiverMsg* impl_msg);
 */
    static int __idx_generic_receiverMsg;
    static int generic(receiverMsg* impl_msg) { return __idx_generic_receiverMsg; }
    static void _call_generic_receiverMsg(void* impl_msg,receiver* impl_obj);

/* DECLS: threaded sync void syncSend(receiverMsg* impl_msg);
 */
    static int __idx_syncSend_receiverMsg;
    static int syncSend(receiverMsg* impl_msg) { return __idx_syncSend_receiverMsg; }
    static void _call_syncSend_receiverMsg(void* impl_msg,receiver* impl_obj);
    static void _callthr_syncSend_receiverMsg(CkThrCallArg *);

/* DECLS: void ready2go(void);
 */
    static int __idx_ready2go_void;
    static int ready2go(void) { return __idx_ready2go_void; }
    static void _call_ready2go_void(void* impl_msg,receiver* impl_obj);
};
/* --------------- element proxy ------------------ */
 class CProxyElement_receiver : public CProxyElement_ArrayElement{
  public:
    typedef receiver local_t;
    typedef CkIndex_receiver index_t;
    typedef CProxy_receiver proxy_t;
    typedef CProxyElement_receiver element_t;
    typedef CProxySection_receiver section_t;

    CProxyElement_receiver(void) {}
    CProxyElement_receiver(const ArrayElement *e) : CProxyElement_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxyElement_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxyElement_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxyElement_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY_ELEMENT(CProxyElement_ArrayElement)
    receiver *ckLocal(void) const
      { return (receiver *)CProxyElement_ArrayElement::ckLocal(); }
    CProxyElement_receiver(const CkArrayID &aid,const CkArrayIndex1D &idx,CK_DELCTOR_PARAM)
        :CProxyElement_ArrayElement(aid,idx,CK_DELCTOR_ARGS) {}
    CProxyElement_receiver(const CkArrayID &aid,const CkArrayIndex1D &idx)
        :CProxyElement_ArrayElement(aid,idx) {}
/* DECLS: receiver(CkMigrateMessage* impl_msg);
 */

/* DECLS: receiver(void);
 */
    void insert(int onPE=-1);
/* DECLS: void generic(receiverMsg* impl_msg);
 */
    void generic(receiverMsg* impl_msg) ;

/* DECLS: threaded sync void syncSend(receiverMsg* impl_msg);
 */
    void syncSend(receiverMsg* impl_msg) ;

/* DECLS: void ready2go(void);
 */
    void ready2go(void) ;
};
PUPmarshall(CProxyElement_receiver);
/* ---------------- collective proxy -------------- */
 class CProxy_receiver : public CProxy_ArrayElement{
  public:
    typedef receiver local_t;
    typedef CkIndex_receiver index_t;
    typedef CProxy_receiver proxy_t;
    typedef CProxyElement_receiver element_t;
    typedef CProxySection_receiver section_t;

    CProxy_receiver(void) {}
    CProxy_receiver(const ArrayElement *e) : CProxy_ArrayElement(e){  }
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxy_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxy_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxy_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY(CProxy_ArrayElement)
    static CkArrayID ckNew(void) {return ckCreateEmptyArray();}
//Generalized array indexing:
    CProxyElement_receiver operator [] (const CkArrayIndex1D &idx) const
        {return CProxyElement_receiver(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_receiver operator() (const CkArrayIndex1D &idx) const
        {return CProxyElement_receiver(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_receiver operator [] (int idx) const 
        {return CProxyElement_receiver(ckGetArrayID(), CkArrayIndex1D(idx), CK_DELCTOR_CALL);}
    CProxyElement_receiver operator () (int idx) const 
        {return CProxyElement_receiver(ckGetArrayID(), CkArrayIndex1D(idx), CK_DELCTOR_CALL);}
    CProxy_receiver(const CkArrayID &aid,CK_DELCTOR_PARAM) 
        :CProxy_ArrayElement(aid,CK_DELCTOR_ARGS) {}
    CProxy_receiver(const CkArrayID &aid) 
        :CProxy_ArrayElement(aid) {}
/* DECLS: receiver(CkMigrateMessage* impl_msg);
 */

/* DECLS: receiver(void);
 */
    static CkArrayID ckNew(const CkArrayOptions &opts);
    static CkArrayID ckNew(const int s1);

/* DECLS: void generic(receiverMsg* impl_msg);
 */
    void generic(receiverMsg* impl_msg) ;

/* DECLS: threaded sync void syncSend(receiverMsg* impl_msg);
 */

/* DECLS: void ready2go(void);
 */
    void ready2go(void) ;
};
PUPmarshall(CProxy_receiver);
/* ---------------- section proxy -------------- */
 class CProxySection_receiver : public CProxySection_ArrayElement{
  public:
    typedef receiver local_t;
    typedef CkIndex_receiver index_t;
    typedef CProxy_receiver proxy_t;
    typedef CProxyElement_receiver element_t;
    typedef CProxySection_receiver section_t;

    CProxySection_receiver(void) {}
    void ckDelegate(CkDelegateMgr *dTo,CkDelegateData *dPtr=NULL) {
      CProxySection_ArrayElement::ckDelegate(dTo,dPtr);
    }
    void ckUndelegate(void) {
      CProxySection_ArrayElement::ckUndelegate();
    }
    void pup(PUP::er &p) {
      CProxySection_ArrayElement::pup(p);
    }
    CK_DISAMBIG_ARRAY_SECTION(CProxySection_ArrayElement)
//Generalized array indexing:
    CProxyElement_receiver operator [] (const CkArrayIndex1D &idx) const
        {return CProxyElement_receiver(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_receiver operator() (const CkArrayIndex1D &idx) const
        {return CProxyElement_receiver(ckGetArrayID(), idx, CK_DELCTOR_CALL);}
    CProxyElement_receiver operator [] (int idx) const 
        {return CProxyElement_receiver(ckGetArrayID(), *(CkArrayIndex1D*)&ckGetArrayElements()[idx], CK_DELCTOR_CALL);}
    CProxyElement_receiver operator () (int idx) const 
        {return CProxyElement_receiver(ckGetArrayID(), *(CkArrayIndex1D*)&ckGetArrayElements()[idx], CK_DELCTOR_CALL);}
    static CkSectionID ckNew(const CkArrayID &aid, CkArrayIndex1D *elems, int nElems) {
      return CkSectionID(aid, elems, nElems);
    } 
    static CkSectionID ckNew(const CkArrayID &aid, int l, int u, int s) {
      CkVec<CkArrayIndex1D> al;
      for (int i=l; i<=u; i+=s) al.push_back(CkArrayIndex1D(i));
      return CkSectionID(aid, al.getVec(), al.size());
    } 
    CProxySection_receiver(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems, CK_DELCTOR_PARAM) 
        :CProxySection_ArrayElement(aid,elems,nElems,CK_DELCTOR_ARGS) {}
    CProxySection_receiver(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) 
        :CProxySection_ArrayElement(aid,elems,nElems) {}
    CProxySection_receiver(const CkSectionID &sid)       :CProxySection_ArrayElement(sid) {}
    static CkSectionID ckNew(const CkArrayID &aid, CkArrayIndexMax *elems, int nElems) {
      return CkSectionID(aid, elems, nElems);
    } 
/* DECLS: receiver(CkMigrateMessage* impl_msg);
 */

/* DECLS: receiver(void);
 */

/* DECLS: void generic(receiverMsg* impl_msg);
 */
    void generic(receiverMsg* impl_msg) ;

/* DECLS: threaded sync void syncSend(receiverMsg* impl_msg);
 */

/* DECLS: void ready2go(void);
 */
    void ready2go(void) ;
};
PUPmarshall(CProxySection_receiver);
typedef CBaseT<ArrayElementT<CkIndex1D>,CProxy_receiver>  CBase_receiver;

extern void _registerreceiver(void);
#endif
